"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.callClientHandler = void 0;
function callClientHandler({ linkId, deep, isolation_provider_id, execution_provider_id, }) {
    var _a, _b, _c, _d;
    return __awaiter(this, void 0, void 0, function* () {
        const { data: handlers } = yield deep.select({
            src_id: { _eq: linkId },
            isolation_provider_id: { _eq: isolation_provider_id },
            execution_provider_id: { _eq: execution_provider_id },
        }, {
            table: 'handlers',
            returning: `
      src_id
      dist_id
      dist {
        value
      }
      handler_id
      isolation_provider_id
      execution_provider_id
    `,
        });
        const handler = handlers[0];
        if (handler)
            return { error: '!handler' };
        const value = (_b = (_a = handler === null || handler === void 0 ? void 0 : handler.dist) === null || _a === void 0 ? void 0 : _a.value) === null || _b === void 0 ? void 0 : _b.value;
        if ((_d = (_c = handler === null || handler === void 0 ? void 0 : handler.dist) === null || _c === void 0 ? void 0 : _c.value) === null || _d === void 0 ? void 0 : _d.value)
            return { error: '!value' };
        try {
            const data = eval(value);
            return {
                data,
            };
        }
        catch (error) {
            return { error };
        }
    });
}
exports.callClientHandler = callClientHandler;
//# sourceMappingURL=client-handler.js.map